//==== This code is used for Monash BoSL team turbidity sensor ====
//==== the following code can be used for PCB sender ====

#include <LowPower.h>

//Define the pins of the chip
#define PTPWR PD6 //the collector pin of phototransistor, power the phototransistor
#define LEDPWR PD7 // the anode of the LED, power the LED
#define MOTPWR PD5 // power the DC motor
#define PTANA PC2 //analogue pin of the phototransistor
#define MCU_RX PD1 //RX pin of the PCB chip
#define MCU_TX PD0 //TX pin of the PCB chip

//Define sensor variables

float AnalogVal; //AnalogVal is the analogue reading of each scan(1 millisecond）
float Analog;//Analog is the average of the analogue reading during the scan period(1 second)
int i; //i is used for set the average calculation of the sensor
int Counter; //Counter is used for get the average value of the analogue reading
char TranAna[10]; //TranAna is the string converted by the Analog transmitting to receiver board

float AnalogValwoLED; //AnalogValwoLED is the analogue reading of each scan without LED(1 millisecond）
float AnalogwoLED;// Analog is the average of the analogue reading during the scan period without LED(1 second)
int iwoLED; //i is used for set the average calculation of the sensor without LED
int CounterwoLED; //Counter is used for get the average value of the analogue reading without LED
char TranAnawoLED[10]; //TranAna is the string converted by the Analog transmitting to receiver board without LED



void setup() {
  Serial.begin(9600);
  Serial.print('R'); //send R to let the reader know that we have already reset
}


void loop(){
  uint8_t cmd;
  if (Serial.available() > 0){
    cmd = Serial.read();

    if(cmd == 'V'){
      Turbscan();
    }
    if(cmd == 'T'){
      TurbscanwoLED();
    }
    if(cmd == 'S'){
      sleepF();
    }
  }
}

void Turbscan(){

  // initialize the digital pin function
  pinMode(PTPWR, OUTPUT);
  pinMode(LEDPWR, OUTPUT);
  pinMode(PTANA, INPUT);
  
  
  AnalogVal = 0;
  Analog = 0;
  i = 0;
  Counter = 0;
  digitalWrite(PTPWR, HIGH);
  digitalWrite(LEDPWR, HIGH);
  
  
  //use for loop to get the analog reading, scan for 1000 times and get the average value
  for(i=0;i<1000;i++)//change the i value to get the working time
  {
    AnalogVal = AnalogVal + analogRead(PTANA)*1.0;
    //AnalogVal = AnalogVal + rand();
    Counter = Counter + 1;
    delay(1);//get the AnalogVal each millisecond, take 1000 times in a single second
  }
    Analog = AnalogVal/Counter;//the average analogue number is the total number divide by the counter time
   digitalWrite(PTPWR, LOW);
   digitalWrite(LEDPWR, LOW);

   dtostrf(Analog, 2, 2, TranAna);

   Serial.print(TranAna);

}

//========== take the analogue reading without LED ==========//

void TurbscanwoLED(){

  // initialize the digital pin function
  pinMode(PTPWR, OUTPUT);
  pinMode(LEDPWR, OUTPUT);
  pinMode(PTANA, INPUT);
  
  
  AnalogValwoLED = 0;
  AnalogwoLED = 0;
  iwoLED = 0;
  CounterwoLED = 0;
  digitalWrite(PTPWR, HIGH);
  digitalWrite(LEDPWR, LOW);
  
  
  //use for loop to get the analog reading, scan for 1000 times and get the average value
  for(iwoLED=0;iwoLED<1000;iwoLED++)//change the i value to get the working time
  {
    AnalogValwoLED = AnalogValwoLED + analogRead(PTANA)*1.0;
    //AnalogVal = AnalogVal + rand();
    CounterwoLED = CounterwoLED + 1;
    delay(1);//get the AnalogVal each millisecond, take 1000 times in a single second
  }
    AnalogwoLED = AnalogValwoLED/CounterwoLED;//the average analogue number is the total number divide by the counter time
   digitalWrite(PTPWR, LOW);
   digitalWrite(LEDPWR, LOW);

   dtostrf(AnalogwoLED, 2, 2, TranAnawoLED);

   Serial.print(TranAnawoLED);

}

void sleepF(){
  LowPower.powerDown(SLEEP_FOREVER, ADC_OFF, BOD_OFF);
}
